const _RPXP_CONTRACTID = "@mozilla.org/rpxp;1";
const _RPXP_CID = Components.ID('{242fab16-2087-40cb-bf7d-606dc7827d1e}');

const CATMAN_CONTRACTID = "@mozilla.org/categorymanager;1";
const JSLOADER_CONTRACTID = "@mozilla.org/moz/jssubscript-loader;1";

/*
 * Module object
 */

var module =
{
	factoryLoaded: false,

	registerSelf: function(compMgr, fileSpec, location, type)
	{
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(_RPXP_CID, 
										"RPXP content policy",
										_RPXP_CONTRACTID,
										fileSpec, location, type);

		var catman = Components.classes[CATMAN_CONTRACTID].getService(Components.interfaces.nsICategoryManager);
		catman.addCategoryEntry("content-policy", _RPXP_CONTRACTID,
							_RPXP_CONTRACTID, true, true);
	},

	unregisterSelf: function(compMgr, fileSpec, location)
	{
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

		compMgr.unregisterFactoryLocation(_RPXP_CID, fileSpec);
		var catman = Components.classes[CATMAN_CONTRACTID].getService(Components.interfaces.nsICategoryManager);
		catman.deleteCategoryEntry("content-policy", _RPXP_CONTRACTID, true);
	},

	getClassObject: function(compMgr, cid, iid)
	{
		if (!cid.equals(_RPXP_CID))
			throw Components.results.NS_ERROR_NO_INTERFACE;

		if (!iid.equals(Components.interfaces.nsIFactory))
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

		if (!this.factoryLoaded)
		{
			var loader = Components.classes[JSLOADER_CONTRACTID].getService(Components.interfaces.mozIJSSubScriptLoader);
			loader.loadSubScript('chrome://rpxp/content/component.js');
			this.factoryLoaded = factory;
		}

		return factory;
	},

	canUnload: function(compMgr)
	{
		return true;
	}
};

// module initialisation
function NSGetModule(comMgr, fileSpec)
{
	return module;
}
